/* Nessus
 * Copyright (C) 1998 Renaud Deraison
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include <config.h>
#include <nessuslib.h>
#include <stdio.h>
#include <stdlib.h>
#ifdef HAVE_STRING_H
#include <string.h>
#endif /* HAVE_STRING_H */
#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif /* HAVE_STRINGS_H */
#include <gtk/gtk.h>

#include "xstuff.h"
#include "auth_dialog.h"
#include "report_file.h"
#include "report.h"
#include "nessus.xpm"
extern struct arglist * hosts;

void main_window_save_report_ask(GtkWidget *, GtkWidget *);
void main_window_save_report(GtkWidget * , GtkWidget * );
void main_window_open_report_ask(GtkWidget *, GtkWidget *);
void main_window_open_report(GtkWidget * , GtkWidget * );

void main_window_setup()
{
 GtkWidget * window;
 GtkWidget * menu;
 GtkWidget * menu_item;
 GtkWidget * menu_title;
 GtkWidget * hbox;
 GtkWidget * vbox;
 GtkWidget * menubar;
 GdkPixmap * pixmap;
 GdkBitmap * mask;
 GtkWidget * pixmapwid;
 GtkStyle *style; 

 
 window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
 gtk_window_set_title(GTK_WINDOW(window), "Nessus");
  gtk_signal_connect(GTK_OBJECT (window), "destroy",
                    GTK_SIGNAL_FUNC(close_display),NULL);
 gtk_signal_connect(GTK_OBJECT(window),"delete_event",
                    GTK_SIGNAL_FUNC(delete_event),NULL);  
                    
 vbox = gtk_vbox_new(FALSE, 0);
 gtk_container_add(GTK_CONTAINER(window), vbox);
 gtk_widget_show(vbox);
 
 hbox = gtk_hbox_new(FALSE, 0);
 gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE,0);
 gtk_widget_show(hbox); 
 style = gtk_widget_get_style(window);
 pixmap = gdk_pixmap_create_from_xpm_d(window->window, &mask, 
 	&style->bg[GTK_STATE_NORMAL],nessus_pixmap);
 pixmapwid = gtk_pixmap_new(pixmap, NULL);
 gtk_box_pack_start(GTK_BOX(vbox), pixmapwid, FALSE, FALSE,0);
 gtk_widget_show(pixmapwid);
 
 menu = gtk_menu_new();
 menu_title = gtk_menu_item_new_with_label("File");
 gtk_widget_show(menu_title);
 
 menu_item = gtk_menu_item_new_with_label("New test...");
 gtk_signal_connect(GTK_OBJECT(menu_item),"activate",
                    (GtkSignalFunc)auth_dialog_setup,NULL);  
 gtk_menu_append(GTK_MENU(menu), menu_item);
 gtk_widget_show(menu_item);
 
 menu_item = gtk_menu_item_new_with_label("Open report...");
  gtk_signal_connect(GTK_OBJECT(menu_item),"activate",
                    (GtkSignalFunc)main_window_open_report_ask,NULL);  
 gtk_menu_append(GTK_MENU(menu), menu_item);
 gtk_widget_show(menu_item);
 
 menu_item = gtk_menu_item_new_with_label("Save report...");
 gtk_signal_connect(GTK_OBJECT(menu_item),"activate",
                    (GtkSignalFunc)main_window_save_report_ask,NULL);  
 gtk_menu_append(GTK_MENU(menu), menu_item);
 gtk_widget_show(menu_item);
 
 menu_item = gtk_menu_item_new_with_label("Quit");
  gtk_signal_connect(GTK_OBJECT(menu_item),"activate",
                    (GtkSignalFunc)close_display,NULL);  
 gtk_menu_append(GTK_MENU(menu), menu_item);
 gtk_widget_show(menu_item);
 gtk_menu_item_set_submenu(GTK_MENU_ITEM (menu_title), menu);
 
 menubar = gtk_menu_bar_new();
 gtk_widget_set_usize(menubar, 200,30);
 gtk_box_pack_start(GTK_BOX(hbox), menubar, FALSE, FALSE, 0);
 gtk_widget_show(menubar);
 gtk_menu_bar_append(GTK_MENU_BAR (menubar), menu_title);
 
 menu = gtk_menu_new();
 menu_title = gtk_menu_item_new_with_label("Edit");
 gtk_widget_show(menu_title);
 
 menu_item = gtk_menu_item_new_with_label("Preferences...");
 gtk_menu_append(GTK_MENU(menu), menu_item);
 gtk_widget_show(menu_item);
 gtk_menu_item_set_submenu(GTK_MENU_ITEM (menu_title), menu);
 gtk_menu_bar_append(GTK_MENU_BAR (menubar), menu_title);
 
 gtk_widget_show(window);
}


void main_window_save_report_ask(GtkWidget * nul, GtkWidget * nul2)
{
 GtkWidget * filew;
 
 if(!hosts)return;
 filew = gtk_file_selection_new ("File selection");
 gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button),
                               "clicked", (GtkSignalFunc) main_window_save_report, filew );
           
 gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION
           (filew)->cancel_button),
             "clicked", (GtkSignalFunc)close_window, (void *)filew);
 gtk_file_selection_set_filename (GTK_FILE_SELECTION(filew), "report.nsr");
           
 gtk_widget_show(filew);
}
 
void main_window_save_report(GtkWidget * nul, GtkWidget * filew)
{
 char * fname = gtk_file_selection_get_filename(GTK_FILE_SELECTION(filew));
 arglist_to_file(hosts, fname);
 gtk_widget_hide(filew);
 gtk_widget_destroy(filew);
}
 
void main_window_open_report_ask(GtkWidget * nul, GtkWidget * nul2)
{
GtkWidget * filew;
 
 filew = gtk_file_selection_new ("File selection");
 gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button),
                               "clicked", (GtkSignalFunc) main_window_open_report, filew
                               );
           
 gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION
           (filew)->cancel_button),
             "clicked", (GtkSignalFunc)close_window, (void*)filew);
 gtk_file_selection_set_filename (GTK_FILE_SELECTION(filew), "report.nsr");
 
 gtk_widget_show(filew);
}

void main_window_open_report(GtkWidget * nul, GtkWidget * filew)
{
 char * fname = gtk_file_selection_get_filename(GTK_FILE_SELECTION(filew));
 struct arglist * hosts;
 hosts = emalloc(sizeof(struct arglist));
 file_to_arglist(hosts, fname);
 gtk_widget_hide(filew);
 gtk_widget_destroy(filew);
 report_tests(hosts);
}

