/* Nessus
 * Copyright (C) 1998 Renaud Deraison
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 */

#include <config.h>
#include <nessuslib.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#ifdef HAVE_STRING_H
#include <string.h>
#endif /* HAVE_STRING_H */
#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif /* HAVE_STRINGS_H */
#include <gtk/gtk.h>
#include "auth_dialog.h"
#include "xstuff.h"
#include "comm.h"
#include "auth.h"
#include "attack.h"
#include "report.h"
#include "main_window.h"

struct arglist * plugins;
struct arglist * hosts;

int connect_to_nessusd(char *, int, char *, char *);



int connect_to_nessusd(hostname, port, login, password)
	char * hostname;
	int port;
	char * login;
	char * password;
	
{
  int soc;

  soc = open_sock_tcp_hn(hostname, port);
  if(soc<0)return(-1);
  if(comm_init(soc))return(-2);
  if(auth_login(login, password))return(-3);
  if(comm_get_pluginlist())return(-4);
  return(0);
}

void init_globals()
{
  plugins = emalloc(sizeof(struct arglist));
  hosts = emalloc(sizeof(struct arglist));
}

void exit_clean(err)
	int err;
{
  switch(err)
  	{
  	case -1 :
  	fprintf(stderr, "Could not open a connection to remote host\n");
  	break;
  	case -2 :
  	case -3 :
  	fprintf(stderr, "Remote host is not using NTP/1.0\n");
  	break;
  	case -4 : 
  	fprintf(stderr, "Login failed\n");
  	break;
  	}
  shutdown(0,2);
  close_display();
  exit(0);
}

void main(int argc, char * argv[])
{
  init_display(&argc, argv);
  init_globals();
  main_window_setup();
  gtk_main();
  exit_clean(0);
}

 
