/* Nessus
 * Copyright (C) 1998 Renaud Deraison
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 */
 
 
#include <config.h>
#include <nessuslib.h>
#include <stdio.h>
#include <stdlib.h>
#ifdef HAVE_STRING_H
#include <string.h>
#endif /* HAVE_STRING_H */
#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif /* HAVE_STRINGS_H */
#include <gtk/gtk.h>

#include "xstuff.h"
#include "plugin_list.h"
struct plugin_list_data {
	GtkWidget * list;
	};
	
	
extern struct arglist * plugins;
static int plugin_listed = 0;

void plugin_list_close(GtkWidget * widget, GtkWidget *w);
void plugin_list_toggle_callback(GtkWidget * w, struct arglist * plugin);
void plugin_list_callback(GtkWidget * widget, GtkWidget * list);
void plugin_list_setup()
{
 GtkWidget * window;
 GtkWidget * scrolled_window;
 GtkWidget * w_box;
 GtkTooltips * tooltips;
 GtkWidget * c_button;
 GList * dlist = NULL;
 struct plugin_list_data data;
 struct arglist * plugs = plugins;
 
 if(plugin_listed)return;
 plugin_listed = 1;
 window = gtk_window_new(GTK_WINDOW_TOPLEVEL); 
 gtk_signal_connect(GTK_OBJECT(window),"delete_event",
  (GtkSignalFunc)plugin_list_close,window);
  
 gtk_window_set_title(GTK_WINDOW(window), "Installed plugins");
 gtk_container_border_width(GTK_CONTAINER(window), 10);
 
 w_box = gtk_vbox_new(FALSE, 0);
 gtk_container_add(GTK_CONTAINER(window), w_box);
 
 scrolled_window = gtk_scrolled_window_new(NULL,NULL);
 gtk_container_border_width(GTK_CONTAINER(scrolled_window), 10);
 gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolled_window),
 	GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
 gtk_widget_set_usize(scrolled_window, 400, 400);
 gtk_box_pack_start(GTK_BOX(w_box), scrolled_window, FALSE, FALSE, 0);
 
 
 
 c_button = gtk_button_new_with_label("Close");
 gtk_box_pack_end(GTK_BOX(w_box), c_button, FALSE, FALSE, 0);
 gtk_signal_connect(GTK_OBJECT(c_button),"clicked",
  (GtkSignalFunc)plugin_list_close,window);
 gtk_widget_show(c_button);
 
 data.list = gtk_list_new();
 
 gtk_container_add(GTK_CONTAINER(scrolled_window), data.list);
 gtk_widget_show(data.list);
 gtk_signal_connect(GTK_OBJECT(data.list),
                              "selection_changed",
                              GTK_SIGNAL_FUNC(plugin_list_callback),
                              data.list);
 
 tooltips = gtk_tooltips_new();

 while(plugs && plugs->next)
 {
	GtkWidget * item;
	GtkWidget * box;
	GtkWidget * button;
	GtkWidget * label;
	char * name;
	
 	item = gtk_list_item_new();
	button = gtk_toggle_button_new_with_label(" Enable ");
	gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), TRUE);
	label = gtk_label_new(plugs->name);
	box = gtk_hbox_new(FALSE,5);
	gtk_box_pack_start(GTK_BOX(box), label, FALSE, FALSE, 0);
	gtk_widget_show(label);
	name = emalloc(40);
	sprintf(name, "[ %s ]", (char*)arg_get_value(plugs->value,"CATEGORY"));
	label = gtk_label_new(name);
	efree(name);
	gtk_box_pack_end(GTK_BOX(box), button, FALSE, FALSE,0);
	gtk_box_pack_end(GTK_BOX(box), label, FALSE,FALSE,10);
	gtk_widget_show(label);
	gtk_container_add(GTK_CONTAINER(item), box);
	gtk_signal_connect(GTK_OBJECT(button),
                              "clicked",
                              GTK_SIGNAL_FUNC(plugin_list_toggle_callback),
                              plugs->value);
	gtk_widget_show(button);
	gtk_widget_show(box);
	gtk_widget_show(item);
	if(arg_get_value(plugs->value, "SUMMARY"))
	gtk_tooltips_set_tip(tooltips, item, 
		(gchar *)arg_get_value(plugs->value, "SUMMARY"),"");
 	dlist = g_list_append(dlist, item);
 	gtk_object_set_data(GTK_OBJECT(item),
                                   "list_item_data",
                                   plugs->name);
 	plugs = plugs->next;
 }
 gtk_tooltips_enable(tooltips);
 gtk_list_append_items(GTK_LIST(data.list), dlist);
 gtk_widget_show(scrolled_window);
 gtk_widget_show(w_box);
 gtk_widget_show(window);
}
 
void plugin_list_close(GtkWidget * widget, GtkWidget *w)
{
	gtk_widget_hide(w);
	plugin_listed = 0;
}


void plugin_list_info_close(GtkWidget * w, GtkWidget *ww)
{
	gtk_widget_hide(ww);
}


void plugin_list_callback(GtkWidget * widget, GtkWidget * list)
{
 GList * dlist;
 GtkObject * list_item;
 char * cur_plug;
 GtkWidget * window;
 GtkWidget * label;
 GtkWidget * box;
 GtkWidget * button;
 char * str;
 struct arglist * plug;
 
 return;
 dlist = GTK_LIST(list)->selection;
 if(!dlist)return;
 list_item = GTK_OBJECT(dlist->data);
 cur_plug = gtk_object_get_data(list_item, "list_item_data");
 
 plug = arg_get_value(plugins, cur_plug);
 window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
 gtk_window_set_title(GTK_WINDOW(window), cur_plug);
 gtk_signal_connect(GTK_OBJECT(window),"delete_event",
  (GtkSignalFunc)plugin_list_info_close,window);

 
 box = gtk_vbox_new(FALSE,0);
 gtk_container_add(GTK_CONTAINER(window), box);
 gtk_widget_show(box);
 
 str = emalloc(strlen(cur_plug)+200);
 sprintf(str, "Name : %s\n", cur_plug);
 label = gtk_label_new(str);
 gtk_box_pack_start(GTK_BOX(box), label, FALSE, FALSE, 0);
 gtk_widget_show(label);
 efree(str);
 
 str = emalloc(strlen(arg_get_value(plug,"DESCRIPTION"))+200);
 sprintf(str, "Description : %s\n", (char *)arg_get_value(plug, "DESCRIPTION"));
 label = gtk_label_new(str);
 gtk_box_pack_start(GTK_BOX(box), label, FALSE, FALSE, 0);
 gtk_widget_show(label);
 efree(str);
 
 str = emalloc(200);
 sprintf(str, "Category : %s\n", (char *)arg_get_value(plug, "CATEGORY"));
 label = gtk_label_new(str);
 gtk_box_pack_start(GTK_BOX(box), label, FALSE, FALSE, 0);
 gtk_widget_show(label);
 efree(str);
 
 
 str = emalloc(strlen(arg_get_value(plug, "COPYRIGHT"))+200);
 sprintf("Copyright : %s\n", (char *)arg_get_value(plug, "COPYRIGHT"));
 label = gtk_label_new(str);
 gtk_box_pack_start(GTK_BOX(box), label, FALSE, FALSE, 0);
 gtk_widget_show(label);
 efree(str);
 
 
 button = gtk_button_new_with_label("Close");
 gtk_box_pack_start(GTK_BOX(box), button, FALSE, FALSE,0);
 gtk_widget_show(button);
 gtk_signal_connect(GTK_OBJECT(button),
                              "clicked",
                              GTK_SIGNAL_FUNC(plugin_list_info_close),
                              window);
                            
  gtk_widget_show(window);                           
 
}

void plugin_list_toggle_callback(GtkWidget * w, struct arglist * plugin)
{
 int state = (int)arg_get_value(plugin, "ENABLED");
 arg_set_value(plugin, "ENABLED", sizeof(int), (void*)!state);
}






  
