/* Nessus
 * Copyright (C) 1998 Renaud Deraison
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Nessus Communication Manager -- it manages the NTP Protocol, version 1.0
 *
 */ 
 
#include <config.h>
#include <nessus-devel.h>
#include <nessuslib.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#ifdef HAVE_STRING_H
#include <string.h>
#endif /* HAVE_STRING_H */
#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif /* HAVE_STRINGS_H */
#include <unistd.h>
#include <signal.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/wait.h>  
#include "auth.h"

struct nessusd_threads {
	char * hostname;
	pid_t pid;
	struct nessusd_threads * next;
	};
	
struct nessusd_threads *nessusd_threads;

void nessusd_threads_init();
void nessusd_thread_register(char * hostname, pid_t pid);
void nessusd_thread_kill_by_name(char * hostname);

void nessusd_threads_init()
{
 nessusd_threads = emalloc(sizeof(struct nessusd_threads));
}

void nessusd_thread_register(char * hostname, pid_t pid)
{  
 struct nessusd_threads * t = nessusd_threads;
 
 while(t && t->next)t = t->next;
 if(!t)return;
 t->hostname = emalloc(strlen(hostname)+1);
 strncpy(t->hostname, hostname, strlen(hostname));
 t->pid = pid;
 t->next = emalloc(sizeof(struct nessusd_threads));
}

void nessusd_thread_kill_by_name(char * hostname)
{
 struct nessusd_threads * t = nessusd_threads;
 while(t && t->next && t->hostname && strcmp(hostname, t->hostname))t = t->next;
 if(t)kill(t->pid, SIGKILL);
 auth_printf("SERVER <|> PING <|> PONG <|> SERVER\n");
}


