/* Nessus
 * Copyright (C) 1998 Renaud Deraison
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Users manager
 *
 */
 
#include <config.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <nessuslib.h>
#include <nessus-devel.h>

#include "log.h"
extern struct arglist * preferences;


struct permission {
 char * permission;
 struct permission * next;
 };
 
struct users {
 char * user;
 char * password;
 struct permission * perms;
 struct users * next;
 };
 
 
int users_init(struct users ** users)
{
 FILE * fd;
 char * fname;
 char * str;
 struct users * l_users;
 *users = emalloc(sizeof(struct users));
 l_usrers = *users;
 fname = arg_get_value(preferences, "usersdb");
 if(!fname)
 {
   log_write("\"usersdb\" not set in "NESSUSD_CONF"\n");
   log_write("now exiting...\n");
   exit(1);
 }
 fd = fopen(fname, "r");
 if(!fd)
 {
   log_write("%s could not be opened -- exiting\n", fname);
   exit(1);
 }
 
 str = emalloc(1024);
 while(fgets(str, 1023, fd) && !feof(fd))
 {
  char * user;
  char * password;
  char * perms_str;
  char * t;
  struct permissions * perms;
  
  user = emalloc(strlen(str)+1);
  password = emalloc(strlen(str)+1);
  perms_str = emalloc(strlen(str)+1);
  sscanf(str, "%s %s %s", user, password, perms_str);
  l_users->name = emalloc(strlen(user)+1);
  strncpy(l_users->name, user, strlen(user));
  l_users->password = emalloc(strlen(password)+1);
  strncpy(l_users->password, password, strlen(password));
  perms = emalloc(sizeof(struct permissions));
  
  t = perms_str;
  while((t=getchr(t, ';')))t[0]=' ';
  t = emalloc(strlen(perms_str)+1);
  
  l_users->perms = perms;
}
 
 
