#include <config.h>
#include <nessus-devel.h>
#include <nessuslib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>   

#define NAME "Imap notifier"
#define DESC "Notify the user that imap is present\n\
There's a bug on some versions of Imap which allow a remote user\n\
to become root using a buffer overflow"
#define COPYRIGHT "ported by Renaud Deraison"
#define SUMM "notifies the user that imap is intalled"



int plugin_init(struct arglist *desc);
int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_GATHER_INFO);
	plug_set_family(desc, "Get root remotely");
	return(0);
}


int plugin_run(struct arglist * args);	
int plugin_run(struct arglist * args)
{
	if(host_get_port_state(args, 143)>0)
		post_info(args, 143, "imap is installed\nIt may be exploitable with a buffer overflow\n");
	
	return(0);
}
